<?php
/*
 Newswriter v2.56
 PHP News Management System
 Copyright (C) 2000-2002 Philipp Wolfer

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the license, or
 (at your option) any later version.
 See license.txt for further information.

 initvars.inc.php, last change: 30.07.2002

 initializing some global variables
*/

// Set error reporting level
// E_ALL for debugging, E_ALL & ~E_NOTICE for normal usage
// or 0 for no errors to be reported
$old_errlvl = error_reporting(E_ALL & ~E_NOTICE);

// remove slash at the end of a path:
function rmv_slash($path)
{
  chop($path);
  if (strrpos($path,'/') == strlen($path) - 1)
    $path = substr($path, 0, strlen($path) - 1);
  return $path;
}

// check if $needle exists in $array
// this function does exist in PHP4 and above
// for older versions it is redefined here
if (!function_exists(in_array)) {
  function in_array($needle, $array)
  {
    if (!is_array($array)) return false;
    while (list($key, $value) = each($array)) {
      if ($value == $needle) return true;
    }
    return false;
  }
}

// initialize $NW_RUNTIME['showlist'] and $NW_RUNTIME['shownot']
function set_topic_arrays()
{
  global $NW_RUNTIME, $NWCONF_INTERFACE;

  // initialize list of topics to be shown in addition to $NW_RUNTIME['showtopic']
  if (isset($NW_RUNTIME['showlist'])) {
    $NW_RUNTIME['showlist'] = explode(',', $NW_RUNTIME['showlist']);

    while (list($key, $value) = each($NW_RUNTIME['showlist'])) {
      $NW_RUNTIME['showlist'][$key] = trim($value);
    }
  }
  else {
    $NW_RUNTIME['showlist'] = array();
  }

// initialize list of topics which will not be shown independent from 'showtopic' and 'showlist'
  if (isset($NW_RUNTIME['shownot'])) {
    $NW_RUNTIME['shownot'] = explode(',', $NW_RUNTIME['shownot']);

    while (list($key, $value) = each($NW_RUNTIME['shownot'])) {
      $NW_RUNTIME['shownot'][$key] = trim($value);
    }
  }
  else {
    if (!is_array($NWCONF_INTERFACE['shownot'])) {
      $NW_RUNTIME['shownot'] = array();
    }
    else {
      $NW_RUNTIME['shownot'] = $NWCONF_INTERFACE['shownot'];
    }
  }

}

// set topic icon extension
if (!$NWCONF_SYSTEM['icon_ext'])
  $NWCONF_SYSTEM['icon_ext'] = '.png';

// initialize some more globak variables:
$NW_INCLUDED = Array();
$NW_MESSAGES = Array();

$NW_INFO['version'] = '2.56-devel';
$NW_INFO['date'] = '27.02.2002';
$NW_INFO['home'] = 'www.newswriter.org';
$NW_INFO['phpversion'] = phpversion();

$NW_RUNTIME['act_timestamp'] = time() + $NWCONF_DISPLAY['time_zone'] * 3600;
$NW_RUNTIME['admin_mode'] = false;

// deactivate magic_quotes_runtime:
if (get_magic_quotes_runtime())
  set_magic_quotes_runtime(0);

// Pruefen, ob Variablen per GET oder POST uebertragen wurden:
if (isset($HTTP_GET_VARS['nwmode']))
  $NW_RUNTIME['nwmode'] = $HTTP_GET_VARS['nwmode'];
elseif (isset($HTTP_POST_VARS['nwmode']))
  $NW_RUNTIME['nwmode'] = $HTTP_POST_VARS['nwmode'];
elseif (isset($nwmode))
  $NW_RUNTIME['nwmode'] = $nwmode;
if (isset($HTTP_GET_VARS['nwaction']))
  $NW_RUNTIME['nwaction'] = $HTTP_GET_VARS['nwaction'];
elseif (isset($HTTP_POST_VARS['nwaction']))
  $NW_RUNTIME['nwaction'] = $HTTP_POST_VARS['nwaction'];
elseif (isset($nwaction))
  $NW_RUNTIME['nwaction'] = $nwaction;
if (isset($HTTP_GET_VARS['nwlogin']))
  $NW_RUNTIME['nwlogin'] = $HTTP_GET_VARS['nwlogin'];
elseif (isset($HTTP_POST_VARS['nwlogin']))
  $NW_RUNTIME['nwlogin'] = $HTTP_POST_VARS['nwlogin'];
if (isset($HTTP_GET_VARS['nwpassword']))
  $NW_RUNTIME['nwpassword'] = $HTTP_GET_VARS['nwpassword'];
elseif (isset($HTTP_POST_VARS['nwpassword']))
  $NW_RUNTIME['nwpassword'] = $HTTP_POST_VARS['nwpassword'];
if (isset($showtopic))
  $NW_RUNTIME['showtopic'] = $showtopic;
elseif (isset($HTTP_GET_VARS['showtopic']))
  $NW_RUNTIME['showtopic'] = $HTTP_GET_VARS['showtopic'];
elseif (isset($HTTP_POST_VARS['showtopic']))
  $NW_RUNTIME['showtopic'] = $HTTP_POST_VARS['showtopic'];
elseif (!isset($NW_RUNTIME['showtopic']))
  $NW_RUNTIME['showtopic'] = 'all';
if (isset($HTTP_GET_VARS['newsmonth']))
  $NW_RUNTIME['newsmonth'] = $HTTP_GET_VARS['newsmonth'];
elseif (isset($HTTP_POST_VARS['newsmonth']))
  $NW_RUNTIME['newsmonth'] = $HTTP_POST_VARS['newsmonth'];

// load language-file:
include($NWCONF_SYSTEM['server_path'].'language/'.$NWCONF_DISPLAY['language'].'.lang'.$NWCONF_SYSTEM['php_ext']);
if (!$NW_TRANSLATION) {
  echo '<p><b>Error loading language file:</b><br />'.$NWCONF_SYSTEM['server_path'].'language/'.$NWCONF_DISPLAY['language'].'.lang'.$NWCONF_SYSTEM['php_ext'].'</p><p>Please check your Newswriter configuration settings.</p>';
  exit;
}

// check for php version:
if ($NW_INFO['phpversion'] < '3.0.10') {
  $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_wrongphp'];
}
if (function_exists('move_uploaded_file')) {
  $NW_RUNTIME['simple_upload'] = false;
}
else {
  $NW_RUNTIME['simple_upload'] = true;
}

// check if track_vars is set:
if (!get_cfg_var('track_vars') && $NW_INFO['phpversion'] < '4.0.3')
  $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_notrackvars'];
//check if perl compatible regular expressions are available:
if (!extension_loaded ('pcre') && !extension_loaded ('PCRE'))
  $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_nopreg'];
if (isset($NW_MESSAGES['setup']))
  $NW_MESSAGES['setup'] = $NW_TRANSLATION['message_configerror'].$NW_MESSAGES['setup'];


// Read user information (Steve's conf.php hack)
if (($NW_RUNTIME['nwmode'] == 'edit' || isset($HTTP_GET_VARS['image'])) && is_array($NWCONF_USERS['alluser'])) {
  $count_user = count($NWCONF_USERS['alluser']);
  for ($xx = 0; $xx != $count_user; $xx++) {
    $NWCONF_USERS['password'][$NWCONF_USERS['alluser'][$xx][0]] = $NWCONF_USERS['alluser'][$xx][1];
    $NWCONF_USERS['realname'][$NWCONF_USERS['alluser'][$xx][0]] = $NWCONF_USERS['alluser'][$xx][2];
    $NWCONF_USERS['email'][$NWCONF_USERS['alluser'][$xx][0]] = $NWCONF_USERS['alluser'][$xx][3];
    $NWCONF_USERS['home'][$NWCONF_USERS['alluser'][$xx][0]] = $NWCONF_USERS['alluser'][$xx][4];
  }
  unset($NWCONF_USERS['alluser']);
}

// Pfadangaben ueberpruefen:
if (!$NWCONF_SYSTEM['template_dir'])
  $NWCONF_SYSTEM['template_dir'] = 'templates';
if (!$NWCONF_SYSTEM['picture_dir'])
  $NWCONF_SYSTEM['picture_dir'] = 'pics';
if (!$NWCONF_SYSTEM['domain_path']) {
  if(dirname($HTTP_SERVER_VARS['SCRIPT_NAME']))
    $NWCONF_SYSTEM['domain_path'] = dirname($HTTP_SERVER_VARS['SCRIPT_NAME']);
  elseif (dirname($SCRIPT_NAME))
    $NWCONF_SYSTEM['domain_path'] = dirname($SCRIPT_NAME);
  elseif (dirname($HTTP_SERVER_VARS['PHP_SELF']))
    $NWCONF_SYSTEM['domain_path'] = dirname($HTTP_SERVER_VARS['PHP_SELF']);
  elseif (dirname($PHP_SELF))
    $NWCONF_SYSTEM['domain_path'] = dirname($PHP_SELF);
}
if (strrpos($NWCONF_SYSTEM['domain_path'],'/') != strlen($NWCONF_SYSTEM['domain_path']) - 1)
  $NWCONF_SYSTEM['domain_path'] = $NWCONF_SYSTEM['domain_path'].'/';
if (strrpos($NWCONF_SYSTEM['template_dir'],'/') != strlen($NWCONF_SYSTEM['template_dir']) - 1)
  $NWCONF_SYSTEM['template_dir'] = $NWCONF_SYSTEM['template_dir'].'/';
if (strrpos($NWCONF_SYSTEM['picture_dir'],'/') != strlen($NWCONF_SYSTEM['picture_dir']) - 1)
  $NWCONF_SYSTEM['picture_dir'] = $NWCONF_SYSTEM['picture_dir'].'/';
$NWCONF_SYSTEM['data_dir'] = rmv_slash($NWCONF_SYSTEM['data_dir']);

// Create data directories:
$old_umask = umask(0);
if (!@is_dir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['data_dir'])) {
  $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_datadirerror1'].$NWCONF_SYSTEM['data_dir'].$NW_TRANSLATION['message_datadirerror2'];
}
else {
  $NWCONF_SYSTEM['news_dir'] = $NWCONF_SYSTEM['data_dir'].'/archiv';
  if (!@is_dir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir'])) {
    $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_setup'];
    $setup = true;
    if (@mkdir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['news_dir'], $NWCONF_SYSTEM['diraccess']))
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_makedir'].$NWCONF_SYSTEM['news_dir'].'<br />';
    else
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_makedirerror'].$NWCONF_SYSTEM['news_dir'].'<br />';
  }
  $NWCONF_SYSTEM['article_dir'] = $NWCONF_SYSTEM['data_dir'].'/article';
  if (!@is_dir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['article_dir'])) {
    if (!$setup) {
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_setup'];
      $setup = true;
    }
    if (@mkdir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['article_dir'], $NWCONF_SYSTEM['diraccess']))
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_makedir'].$NWCONF_SYSTEM['article_dir'].'<br />';
    else
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_makedirerror'].$NWCONF_SYSTEM['article_dir'].'<br />';
  }
  $NWCONF_SYSTEM['imgupload_dir'] = $NWCONF_SYSTEM['data_dir'].'/images';
  if (!@is_dir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['imgupload_dir']) && $NWCONF_INTERFACE['allow_imgupload']) {
    if (!$setup) {
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_setup'];
      $setup = true;
    }
    if (@mkdir($NWCONF_SYSTEM['server_path'].$NWCONF_SYSTEM['imgupload_dir'], $NWCONF_SYSTEM['diraccess']))
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_makedir'].$NWCONF_SYSTEM['imgupload_dir'].'<br />';
    else
      $NW_MESSAGES['setup'] .= $NW_TRANSLATION['message_makedirerror'].$NWCONF_SYSTEM['imgupload_dir'].'<br />';
  }
}
umask($old_umask);
?>
